<html>
<head>
<title>OGRE: OgreRenderQueueInvocation.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreRenderQueueInvocation.h</h1><a href="OgreRenderQueueInvocation_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2005 The OGRE Team</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __RenderQueueInvocation_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __RenderQueueInvocation_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreRenderQueueSortingGrouping_8h.html">OgreRenderQueueSortingGrouping.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00061"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html">00061</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>
<a name="l00062"></a>00062     {
<a name="l00063"></a>00063     <span class="keyword">protected</span>:
<a name="l00065"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#9d62e3b89ff7a4c8788e6acfee402184">00065</a>         <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> mRenderQueueGroupID;
<a name="l00067"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#25a715bb1dac5418611625a26ea09c72">00067</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mInvocationName;
<a name="l00069"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#96cbe4914fdc8bb421f8b62aff7a4c54">00069</a>         <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a> mSolidsOrganisation;
<a name="l00071"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#4eac5c298760a11cfe64daf860e638df">00071</a>         <span class="keywordtype">bool</span> mSuppressShadows;
<a name="l00073"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#e262d7e8f6e75227b83bc816b1327fda">00073</a>         <span class="keywordtype">bool</span> mSuppressRenderStateChanges;
<a name="l00074"></a>00074     <span class="keyword">public</span>:
<a name="l00080"></a>00080         <a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>(<a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> renderQueueGroupID, 
<a name="l00081"></a>00081             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; invocationName = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00082"></a>00082         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>();
<a name="l00083"></a>00083 
<a name="l00085"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#e4fa00491fa5cf3bebfc7816240f4418">00085</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getRenderQueueGroupID(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRenderQueueGroupID; }
<a name="l00086"></a>00086 
<a name="l00088"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#9661bf4bc551c597918ffd3b87b2826e">00088</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getInvocationName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mInvocationName; }
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#6a37071d01a609e279081a906a856dc1">00093</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSolidsOrganisation(
<a name="l00094"></a>00094             <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a> org)  
<a name="l00095"></a>00095         { mSolidsOrganisation = org; }
<a name="l00096"></a>00096 
<a name="l00100"></a>00100         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">QueuedRenderableCollection::OrganisationMode</a>
<a name="l00101"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#e7a631496cc38bd768569605b5dba3c5">00101</a>             getSolidsOrganisation(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSolidsOrganisation; }
<a name="l00102"></a>00102 
<a name="l00108"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#bc2c82b2c2d72aede9a6a560235e7c27">00108</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSuppressShadows(<span class="keywordtype">bool</span> suppress) 
<a name="l00109"></a>00109         { mSuppressShadows =  suppress; }
<a name="l00110"></a>00110 
<a name="l00113"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#878fae20bf95f1dff6e4de60340df620">00113</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getSuppressShadows(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSuppressShadows; }
<a name="l00114"></a>00114 
<a name="l00135"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#4d3821747ee0588c65bfc48982c7e37b">00135</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSuppressRenderStateChanges(<span class="keywordtype">bool</span> suppress) 
<a name="l00136"></a>00136         { mSuppressRenderStateChanges =  suppress; }
<a name="l00137"></a>00137 
<a name="l00140"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#ad7b785b1150206ad5adc732d4e7e7cf">00140</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getSuppressRenderStateChanges(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSuppressRenderStateChanges; }
<a name="l00141"></a>00141 
<a name="l00147"></a>00147         <span class="keyword">virtual</span> <span class="keywordtype">void</span> invoke(<a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at...">RenderQueueGroup</a>* group, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* targetSceneManager);
<a name="l00148"></a>00148 
<a name="l00150"></a><a class="code" href="classOgre_1_1RenderQueueInvocation.html#27d41c4a90547ca4a976ac88c53fa3e6">00150</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> RENDER_QUEUE_INVOCATION_SHADOWS;
<a name="l00151"></a>00151     };
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00155"></a><a class="code" href="namespaceOgre.html#36e988ee6880dc974a0612da3863bb5f">00155</a>     <span class="keyword">typedef</span> std::vector&lt;RenderQueueInvocation*&gt; <a class="code" href="namespaceOgre.html#36e988ee6880dc974a0612da3863bb5f" title="List of RenderQueueInvocations.">RenderQueueInvocationList</a>;
<a name="l00156"></a><a class="code" href="namespaceOgre.html#ce1177231e9c350bbf4d9862f189b13e">00156</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">VectorIterator&lt;RenderQueueInvocationList&gt;</a> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">RenderQueueInvocationIterator</a>;
<a name="l00157"></a>00157 
<a name="l00168"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html">00168</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>
<a name="l00169"></a>00169     {
<a name="l00170"></a>00170     <span class="keyword">protected</span>:
<a name="l00171"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#7a61d04ea84f2ded758094702c7648a0">00171</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mName;
<a name="l00172"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#e567ddc2821336b54441e83f550cc74f">00172</a>         <a class="code" href="namespaceOgre.html#36e988ee6880dc974a0612da3863bb5f" title="List of RenderQueueInvocations.">RenderQueueInvocationList</a> mInvocations;
<a name="l00173"></a>00173     <span class="keyword">public</span>:
<a name="l00174"></a>00174         <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00175"></a>00175         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>();
<a name="l00176"></a>00176 
<a name="l00178"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#2077bfd191b704ccbf207056ac3551d3">00178</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00179"></a>00179 
<a name="l00186"></a>00186         <a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>* <span class="keyword">add</span>(<a class="code" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> renderQueueGroupID, 
<a name="l00187"></a>00187             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; invocationName);
<a name="l00188"></a>00188 
<a name="l00195"></a>00195         <span class="keywordtype">void</span> <span class="keyword">add</span>(<a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>* i);
<a name="l00196"></a>00196 
<a name="l00198"></a><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html#ddf91fd804baf0b2d03dab38c6ebc105">00198</a>         <span class="keywordtype">size_t</span> size(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mInvocations.size(); }
<a name="l00199"></a>00199 
<a name="l00201"></a>00201         <span class="keywordtype">void</span> clear(<span class="keywordtype">void</span>);
<a name="l00202"></a>00202 
<a name="l00204"></a>00204         <a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>* <span class="keyword">get</span>(<span class="keywordtype">size_t</span> index);
<a name="l00205"></a>00205 
<a name="l00207"></a>00207         <span class="keywordtype">void</span> <span class="keyword">remove</span>(<span class="keywordtype">size_t</span> index);
<a name="l00208"></a>00208 
<a name="l00210"></a>00210         <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">RenderQueueInvocationIterator</a> iterator(<span class="keywordtype">void</span>);
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213     };
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="preprocessor">#endif</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
